/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.1
 * Date               : 2020/08/06
 * Description        :
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "CONFIG.h"
#include "hal.h"
#include "central.h"

/*********************************************************************
 * GLOBAL TYPEDEFS
 */
__attribute__((aligned(4))) uint32_t MEM_BUF[BLE_MEMHEAP_SIZE / 4];

#if(defined(BLE_MAC)) && (BLE_MAC == TRUE)
const uint8_t MacAddr[6] = {0x84, 0xC2, 0xE4, 0x03, 0x02, 0x02};
#endif

/*********************************************************************
 * @fn      Main_Circulation
 *
 * @brief   ѭ
 *
 * @return  none
 */
__HIGH_CODE
__attribute__((noinline))
void Main_Circulation()
{
    while(1)
    {
        TMOS_SystemProcess();
    }
}

#define BOARD_PID_PRINTF_EVT    0x0008  /*PIDλӡ*/

static uint8_t Board_TaskID = INVALID_TASK_ID;  //弶

tmosEvents Board_ProcessEvent(tmosTaskID task_id,tmosEvents events)
{
    //ϵͳϢ
    if(events & SYS_EVENT_MSG)
    {
        uint8_t *pMsg;
        if((pMsg = tmos_msg_receive(Board_TaskID)) != NULL)
        {
            PRINT("recvice data:");
            for(uint8_t i=0;i<8;i++)
                PRINT("%02x ",pMsg[i]);
        }
        PRINT("\r\n");
        tmos_msg_deallocate(pMsg);

        return (events ^ SYS_EVENT_MSG);
    }

    if(events & BOARD_PID_PRINTF_EVT)
    {
      PRINT("d:%d,%d,%d,%X,%d,%d\n",0,
                                    0,
                                    0,
                                    *((volatile uint32_t *)0x40005008),
                                    *((volatile uint8_t *)0x40005008),
                                    *((volatile uint8_t *)0x40005009));
      return (events ^ BOARD_PID_PRINTF_EVT);
    }
    return 0;
}
/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main(void)
{
#if(defined(DCDC_ENABLE)) && (DCDC_ENABLE == TRUE)
    PWR_DCDCCfg(ENABLE);
#endif
    SetSysClock(CLK_SOURCE_PLL_60MHz);
#if(defined(HAL_SLEEP)) && (HAL_SLEEP == TRUE)
    GPIOA_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
    GPIOB_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
#endif
#ifdef DEBUG
    GPIOA_SetBits(bTXD1);
    GPIOA_ModeCfg(bTXD1, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
#endif
    PRINT("%s\n", VER_LIB);
    CH58X_BLEInit();
    HAL_Init();
    GAPRole_CentralInit();
    Central_Init();

    Board_TaskID = TMOS_ProcessEventRegister(Board_ProcessEvent);   //ע弶¼
    tmos_start_reload_task(Board_TaskID, BOARD_PID_PRINTF_EVT, 60);  //ӡ

    Main_Circulation();
}

/******************************** endfile @ main ******************************/
